function [es,vs,h0]=globfun_final(ten,rey,pe,dl2,n,x,dx,h0,beta0)

%useful groups
dx1=1/2/dx;
dx3=1/2/dx/dx/dx;

hx1=zeros(1,n);
hxxx1=zeros(1,n);

h1=stat1(x,dx,ten,rey,dl2,pe,n,h0);

h0=h1;

% calculate the higher derivatives
hxxx1(1) = (-3*h1(5)+14*h1(4)-24*h1(3) +18*h1(2)-5*h1(1))*dx3;
hxxx1(2) = (-h1(5)+6*h1(4)-12*h1(3)+10*h1(2)-3*h1(1))*dx3;
hxxx1(3:n-2) = (h1(5:n)-2*h1(4:n-1) +2*h1(2:n-3)-h1(1:n-4))*dx3;
hxxx1(n-1) = (h1(n-4)-6*h1(n-3)+12*h1(n-2)-10*h1(n-1)+3*h1(n))*dx3;
hxxx1(n) = (3*h1(n-4)-14*h1(n-3)+24*h1(n-2)-18*h1(n-1)+5*h1(n))*dx3;

hx1(1) = (-3*h1(1) +4*h1(2) - h1(3))*dx1;
hx1(2:n-1) = (h1(3:n) - h1(1:n-2))*dx1;
hx1(n) = (h1(n-2) - 4*h1(n-1) + 3*h1(n))*dx1;

% setup the matricies
% er is the error eigenvalue
er=-100;

% sig x = Ax
A=zeros(2*n,2*n);

r12=12/rey;

% quadrant 1
% enforcing height conditions
A(1,1)=er;
A(n,n)=er;

% quadrant 2
for k=2:n-1;
    A(k,n+k-1:n+k+1) = -dx1*[-1,0,1];
end

% quadrant 3
A(n+1,1:4) = zeros(1,4);
A(n+2,1:5) = dx3*ten*h1(2)*[-3,10,-12,6,-1]+ ten*hxxx1(2)*[0,1,0,0,0]...
    + dx1*1.2/h1(2)/h1(2)*[-1,0,1,0,0] - 2.4*hx1(2)/h1(2)/h1(2)/h1(2)*[0,1,0,0,0]...
    + r12*(2/h1(2)/h1(2)/h1(2))*[0,1,0,0,0];
for k=3:n-2;
    A(k+n,k-2:k+2) = dx3*ten*h1(k)*[-1,2,0,-2,1] + ten*hxxx1(k)*[0,0,1,0,0]...
        + dx1*1.2/h1(k)/h1(k)*[0,-1,0,1,0]- 2.4*hx1(k)/h1(k)/h1(k)/h1(k)*[0,0,1,0,0]...
        + r12*(2/h1(k)/h1(k)/h1(k))*[0,0,1,0,0];
end
A(2*n-1,n-4:n) = dx3*ten*h1(n-1)*[1,-6,12,-10,3] + ten*hxxx1(n-1)*[0,0,0,1,0]...
    + dx1*1.2/h1(n-1)/h1(n-1)*[0,0,-1,0,1] - 2.4*hx1(n-1)/h1(n-1)/h1(n-1)/h1(n-1)*[0,0,0,1,0]...
    + r12*(2/h1(n-1)/h1(n-1)/h1(n-1))*[0,0,0,1,0];
A(2*n,n-3:n) = -ten/dl2/dx/dx*[-1,4,-5,2];

% quadrant 4
A(n+1,n+1)=er;
for k=2:n-1;
    A(k+n,n+k-1:n+k+1) = -2.4*dx1/h1(k)*[-1,0,1]+ 2.4*hx1(k)/h1(k)/h1(k)*[0,1,0]...
        -r12/h1(k)/h1(k)*[0,1,0];
end
A(2*n,2*n)=-r12;

% enforcing flux condition
[v,e]=eig(A);

e=diag(e);

k=1;


[et,is]=sort(abs(real(e)));

et=e(is);


for j=1:length(e);
    if  abs(abs(imag(e(j))) - beta0)/beta0 < 0.5 && abs(imag(e(j)))>0.01;
        ej(k,1)=e(j);
        vj(:,k)=v(:,j);
        k=k+1;
    end
end

[es,is]=sort(abs(real(ej)));
es=ej(is);
vs=vj(:,is);




