
function h=stat1(x,dx,ten,rey,dl2,pe,n,h0)

% reset initial conditions
u0=h0;

options=optimset('TolX',1e-3,'TolFun',1e-3);
[h,fv,exit] = fsolve(@stat,u0,options);

if exit<0
    exit
    pause
end

    function v = stat(h)
        
        r12=12/rey;
       
        % calculate one point outside the domain using the downstream boundary condition
        hz= 2 - h(n-1) + (dx*dx/ten)*(pe-r12*dl2);
        
        v(1) = h(1)-1;
        v(2) = 1.2*(1./h(2)^2)*(h(3)-h(1))/2/dx...
            + ten*h(2)*(-3*h(1)+10*h(2)-12*h(3)+6*h(4)-h(5))/2/dx/dx/dx...
            - r12*(1/(h(2)^2));
        v(3:n-2) = 1.2*(1./h(3:n-2).^2).*(h(4:n-1)-h(2:n-3))/2/dx...
            + ten*h(3:n-2).*(h(5:n)-2*h(4:n-1)+2*h(2:n-3)-h(1:n-4))/2/dx/dx/dx...
            - r12*(1./(h(3:n-2).^2));
        v(n-1) = 1.2*(1./h(n-1)^2)*(h(n)-h(n-2))/2/dx...
            + ten*h(n-1)*(hz-2+2*h(n-2)-h(n-3))/2/dx/dx/dx...
            - r12*(1/(h(n-1)^2));
        v(n) = h(n)-1;
        
    end

end